# coding: utf-8

"""
    Kalshi Trade API

    This documentation describes Kalshi's trading API (known as Trade API v2). By using this API, you agree to Kalshi's Developer Agreement (https://kalshi.com/developer-agreement).  # noqa: E501

    OpenAPI spec version: 2.0.0
    Contact: support@kalshi.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GetMarketsResponse(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cursor': 'str',
        'markets': 'list[Market]'
    }

    attribute_map = {
        'cursor': 'cursor',
        'markets': 'markets'
    }

    def __init__(self, cursor=None, markets=None):  # noqa: E501
        """GetMarketsResponse - a model defined in Swagger"""  # noqa: E501
        self._cursor = None
        self._markets = None
        self.discriminator = None
        if cursor is not None:
            self.cursor = cursor
        self.markets = markets

    @property
    def cursor(self):
        """Gets the cursor of this GetMarketsResponse.  # noqa: E501

        The Cursor represents a pointer to the next page of records in the pagination. Use the value returned here in the cursor query parameter for this end-point to get the next page containing limit records. An empty value of this field indicates there is no next page.  # noqa: E501

        :return: The cursor of this GetMarketsResponse.  # noqa: E501
        :rtype: str
        """
        return self._cursor

    @cursor.setter
    def cursor(self, cursor):
        """Sets the cursor of this GetMarketsResponse.

        The Cursor represents a pointer to the next page of records in the pagination. Use the value returned here in the cursor query parameter for this end-point to get the next page containing limit records. An empty value of this field indicates there is no next page.  # noqa: E501

        :param cursor: The cursor of this GetMarketsResponse.  # noqa: E501
        :type: str
        """

        self._cursor = cursor

    @property
    def markets(self):
        """Gets the markets of this GetMarketsResponse.  # noqa: E501


        :return: The markets of this GetMarketsResponse.  # noqa: E501
        :rtype: list[Market]
        """
        return self._markets

    @markets.setter
    def markets(self, markets):
        """Sets the markets of this GetMarketsResponse.


        :param markets: The markets of this GetMarketsResponse.  # noqa: E501
        :type: list[Market]
        """
        if markets is None:
            raise ValueError("Invalid value for `markets`, must not be `None`")  # noqa: E501

        self._markets = markets

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GetMarketsResponse, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetMarketsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
